#include <stdio.h>
#include <gemdefs.h>
#include <obdefs.h>

void do_trees();
void do_objects();
void do_tedinfo();
void do_iconblk();
void do_bitblk();
void do_freestring();
void do_freeimages();
void dump_image();
void bload();
void do_header();
RSHDR header;
char *buffer;
FILE *fout;

main(ac,av)int ac;char *av[];
{
	if(ac!=3)
	{
		fprintf(stderr,"rsc2src resource-file output-file\n");
		exit(1);
	}
	bload(av[1],&buffer);
	memcpy(&header,buffer,sizeof(RSHDR));
	if((fout=fopen(av[2],"w"))==NULL)
	{
		fprintf(stderr,"Can't create %s\n",av[2]);
		exit(2);
	}
	do_header(header.rsh_ntree,header.rsh_nimages,header.rsh_nstring);
	do_trees(header.rsh_trindex,header.rsh_ntree);
	do_objects(header.rsh_object,header.rsh_nobs);
	do_tedinfo(header.rsh_tedinfo,header.rsh_nted);
	do_iconblk(header.rsh_iconblk,header.rsh_nib);
	do_bitblk(header.rsh_bitblk,header.rsh_nbb);
	do_freestring(header.rsh_frstr,header.rsh_nstring);
	do_freeimages(header.rsh_frimg,header.rsh_nimages);
	fclose(fout);
	exit(0);
}

void do_trees(start,no)unsigned start,no;
{
	long	*a;
	int	i;

	if(no==0) return;
	a=buffer+start;
	fprintf(fout,".trees\n");
	for(i=0;i<no;i++)
		fprintf(fout,"\tdc.l\t.o%lx\n",*a++);
	fprintf(fout,"\tdc.l\t0\n");
}

void do_objects(start,no)unsigned start,no;
{
	unsigned i,k;
	OBJECT *obj;
	char *a;

	obj=buffer+start;
	if(no==0) return;	
	for(i=0;i<no;i++)
	{
		fprintf(fout,".o%lx",(long)obj-(long)buffer);
		fprintf(fout,"\tdc.w\t$%04x,$%04x,$%04x\n",
			obj->ob_next,obj->ob_head,obj->ob_tail);
		fprintf(fout,"\tdc.w\t$%04x,$%04x,$%04x\n",
			obj->ob_type,obj->ob_flags,obj->ob_state);
		fprintf(fout,"\tdc.l\t");
		switch(obj->ob_type)
		{
		case G_BOX:
		case G_IBOX:
		case G_BOXCHAR:
			a="$";
			break;
		case G_TEXT:
		case G_FTEXT:
		case G_BOXTEXT:
		case G_FBOXTEXT:
			a=".ted";
			break;
		case G_ICON:
			a=".icon";
			break;
		case G_IMAGE:
			a=".image";
			break;
		case G_BUTTON:
		case G_STRING:
		case G_TITLE:
			a=".string";
			break;
		default:
			a="error";
			break;
		}
		fprintf(fout,"%s%lx\n",a,(long)obj->ob_spec);
		fprintf(fout,"\tdc.w\t$%04x,$%04x,$%04x,$%04x\n",
			obj->ob_x,obj->ob_y,obj->ob_width,obj->ob_height);
		obj++;
	}
	obj = buffer+start;
	k=0;
	for(i=0;i<no;i++,obj++)
	{
		switch(obj->ob_type)
		{
		case G_BUTTON:
		case G_STRING:
		case G_TITLE:
			k=1;
			fprintf(fout,".string%lx\tdc.b\t\"%s\",0\n",
				obj->ob_spec,buffer+obj->ob_spec);
		default:
			break;
		}
	}
	if(k==1)fprintf(fout,"\teven\n");
}

void do_bitblk(start,no)unsigned start,no;
{
	BITBLK *bitblk;
	int i;
	char *a;
	short *img;

	if(no==0) return;
	bitblk=buffer+start;
	for(i=0;i<no;i++,bitblk++)
	{
		a="$";
		fprintf(fout,".image%lx\tdc.l\t.iimage%lx\n",
			(long)bitblk-(long)buffer,bitblk->bi_pdata);
		fprintf(fout,"\tdc.w\t");
		for(img=(&bitblk->bi_wb);img<= &bitblk->bi_color;img++)
		{
			fprintf(fout,"%s%04x",a,*img);
			a=",$";
		}
		fprintf(fout,"\n");
	}
	bitblk=buffer+start;
	for(i=0;i<no;i++,bitblk++)
	{
		img=bitblk->bi_pdata;
		fprintf(fout,".iimage%lx\tdc.w\t",img);
		dump_image(buffer+(long)img,(bitblk->bi_wb>>1)*bitblk->bi_hl);
	}
}

void dump_image(img,size)short *img;int size;
{
	char *a;
	int j;

	a="$";
	for(j=0;j<size;j++)
	{
		if(3==(j%4))
			fprintf(fout,"\n\tdc.w\t$");
		else
		{
			fprintf(fout,"%s",a);
			a=",$";
		}
		fprintf(fout,"%04x",*img++);
	}
	fprintf(fout,"\n");
}

void do_tedinfo(start,no)
{
	TEDINFO *ted;
	int i;
	short *b;

	if(no==0)return;
	
	ted=buffer+start;
	for(i=0;i<no;i++,ted++)
	{
		fprintf(fout,".ted%lx",(long)ted-(long)buffer);
		fprintf(fout,"\tdc.l\t.string%lx\n",
			ted->te_ptext);
		fprintf(fout,"\tdc.l\t.string%lx\n",
			ted->te_ptmplt);
		fprintf(fout,"\tdc.l\t.string%lx\n",
			ted->te_pvalid);
		for(b=&ted->te_font;b<= &ted->te_tmplen;b++)
			fprintf(fout,"\tdc.w\t$%04x\n",*b);
	}		
	ted=buffer+start;
	for(i=0;i<no;i++,ted++)
	{
		fprintf(fout,".string%lx\tdc.b\t\"%s\",0\n",
			ted->te_ptext,ted->te_ptext+(long)buffer);
		fprintf(fout,".string%lx\tdc.b\t\"%s\",0\n",
			ted->te_pvalid,ted->te_pvalid+(long)buffer);
		fprintf(fout,".string%lx\tdc.b\t\"%s\",0\n",
			ted->te_ptmplt,ted->te_ptmplt+(long)buffer);
	}
	if(no!=0)
		fprintf(fout,"\teven\n");
}

void do_iconblk(start,no)
{
	ICONBLK *icon;
	int i,k,*img,size;

	if(no==0)return;
	icon=buffer+start;
	for(i=0;i<no;i++,icon++)
	{
		fprintf(fout,".icon%lx\tdc.l\t.iimage%lx\n",
			(long)icon-(long)buffer,icon->ib_pmask);
		fprintf(fout,"\tdc.l\t.iimage%lx\n",
			icon->ib_pdata);
		fprintf(fout,"\tdc.l\t.string%lx\n",icon->ib_ptext);
		k=0;
		for(img=&icon->ib_char;img<= &icon->ib_htext;img++)
		{
			if(k>3) k=0;
			if(k==0)
				fprintf(fout,"\n\tdc.w\t$");
			else
				fprintf(fout,",$");
			k++;
			fprintf(fout,"%04x",*img);
		}
	}
	fprintf(fout,"\n");
	icon = buffer+start;
	for(i=0;i<no;i++,icon++)
	{
		img=icon->ib_pmask;
		size=(icon->ib_wicon>>4)*icon->ib_hicon;
		fprintf(fout,".iimage%lx\tdc.w\t",img);
		dump_image((long)img+(long)buffer,size);
		img=icon->ib_pdata;
		fprintf(fout,".iimage%lx\tdc.w\t",img);
		dump_image((long)img+(long)buffer,size);
	}
	icon=buffer+start;
	for(i=0;i<no;i++,icon++)
	{
		img=icon->ib_ptext;
		fprintf(fout,".string%lx\tdc.b\t\"%s\",0\n",
			img,(long)img+(long)buffer);
	}
	fprintf(fout,"\teven\n");
	
}

void do_freestring(start,no)
{
	long *str;
	int i;
	if(no==0) return;
	str=buffer+start;
	fprintf(fout,".freestrings\n");
	for(i=0;i<no;i++,str++)
		fprintf(fout,"\tdc.l\t.string%lx\n",*str++);
	str=buffer+start;
	for(i=0;i<no;i++,str++)
		fprintf(fout,".string%lx\tdc.b\t\"%s\",0\n",
			*str,buffer+(*str));
	fprintf(fout,"\teven\n");
}
	
void do_freeimages(start,no)
{
	long *img;
	int i;

	if(no==0)return;
	fprintf(fout,".freeimages\n");
	img=buffer+start;
	for(i=0;i<no;i++,img++)
		fprintf(fout,"\tdc.l\t.image%lx\n",*img);
}

void bload(s,b)char *s,**b;
{
	FILE *fin;
	long pos;
	extern char *lmalloc();

	if((fin=fopen(s,"rb"))==NULL)
	{
		fprintf(stderr,"can't open %s\n",s);
		exit(1);
	}
	fseek(fin,0L,2);
	pos=ftell(fin);
	rewind(fin);
	*b=lmalloc(pos);
	fread(*b,1,(unsigned int) pos,fin);
	fclose(fin);
}

void do_header(ntrees,nimages,nstrings)
{

	fprintf(fout,"\tdc.l\t%s\n",ntrees!=0?".trees":"0");
	fprintf(fout,"\tdc.l\t%s\n",nimages!=0?".freeimages":"0");
	fprintf(fout,"\tdc.l\t%s\n",nstrings!=0?".freestrings":"0");
}
